<?php
/*
Dragon Go Server
Copyright (C) 2001-2007  Erik Ouchterlony, Rod Ival

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

if( @$_REQUEST['nextgame']
      or @$_REQUEST['nextstatus']
      or @$_REQUEST['nextback']
      or @$_REQUEST['nextskip']
      or @$_REQUEST['nextaddtime']
   )
{
//confirm use $_REQUEST: gid, move, action, coord, stonestring
   include_once( "confirm.php");
   exit; //should not be executed
}

$TranslateGroups[] = "Game";

require_once( "include/std_functions.php" );
require_once( "include/game_functions.php" );
require_once( "include/form_functions.php" );
require_once( "include/board.php" );
require_once( "include/move.php" );
require_once( "include/rating.php" );
if( ENA_STDHANDICAP ) {
require_once( "include/sgf_parser.php" );
}

// abbreviations used to reduce file size
function get_alt_arg( $n1, $n2)
{
// $_GET must have priority at least for those used in the board links
// for instance, $_POST['coord'] is the current (last used) coord
// while $_GET['coord'] is the coord selected in the board (next coord)

   if( isset( $_GET[$n1]) )
      return $_GET[$n1];
   if( isset( $_GET[$n2]) )
      return $_GET[$n2];

   if( isset( $_POST[$n1]) )
      return $_POST[$n1];
   if( isset( $_POST[$n2]) )
      return $_POST[$n2];

   return '';
}

{

   $gid = (int)get_alt_arg( 'gid', 'g');
   $action = (string)get_alt_arg( 'action', 'a');
   $move = (int)get_alt_arg( 'move', 'm'); //move number
   $coord = (string)get_alt_arg( 'coord', 'c');
   $stonestring = (string)get_alt_arg( 'stonestring', 's');

   $message = get_request_arg( 'message');


   connect2mysql();

   if( $gid <= 0 )
      error('no_game_nr');

   $logged_in = who_is_logged( $player_row);

//    if( !$logged_in )
//       error('not_logged_in');

   if( $logged_in )
      $my_id = $player_row['ID'];
   else
      $my_id = 0;

   if( $logged_in && @$_REQUEST['toggleobserve'] )
      toggle_observe_list($gid, $my_id);


   $query= "SELECT Games.*, " .
           "Games.Flags+0 AS GameFlags, " . //used by check_move
           "black.Name AS Blackname, " .
           "black.Handle AS Blackhandle, " .
           "black.OnVacation>0 AS Blackwarning, " .
           "black.Rank AS Blackrank, " .
           "black.Rating2 AS Blackrating, " .
           "black.RatingStatus AS Blackratingstatus, " .
           "white.Name AS Whitename, " .
           "white.Handle AS Whitehandle, " .
           "white.OnVacation>0 AS Whitewarning, " .
           "white.Rank AS Whiterank, " .
           "white.Rating2 AS Whiterating, " .
           "white.RatingStatus AS Whiteratingstatus " .
           "FROM Games, Players AS black, Players AS white " .
           "WHERE Games.ID=$gid AND Black_ID=black.ID AND White_ID=white.ID";

   if( !($game_row=mysql_single_fetch( 'game.findgame', $query)) )
      error('unknown_game','game.findgame');

   extract($game_row);

   if( $Status == 'INVITED' )
      error('unknown_game','game.invited');


   if( @$_REQUEST['movechange'] )
      $move = (int)@$_REQUEST['gotomove'];
   if( $move<=0 )
      $move = $Moves;
   if( $Status == 'FINISHED' or $move < $Moves )
   {
      $may_play = false;
      $just_looking = true;
   }
   else
   {
      $may_play = ( $logged_in and $my_id == $ToMove_ID ) ;
      $just_looking = !$may_play;
      if( $may_play )
      {
         if( !$action )
         {
            if( $Status == 'PLAY' )
            {
               if( $Handicap>1 && $Moves==0 )
                  $action = 'handicap';
               else
                  $action = 'choose_move';
            }
            else if( $Status == 'PASS' )
            {
               $action = 'choose_move';
            }
            else if( $Status == 'SCORE' or $Status == 'SCORE2' )
               $action = 'remove';
         }
      }
   }


   // ??? no more useful:
   if( !$just_looking && $logged_in && $my_id != $ToMove_ID )
      error('not_your_turn');

   // allow validation
   if ( $just_looking && $action == 'add_time' )
      $just_looking = false;

   $my_game = ( $logged_in && ( $my_id == $Black_ID or $my_id == $White_ID ) ) ;

   $too_few_moves = ($Moves < DELETE_LIMIT+$Handicap) ;

   if( $Black_ID == $ToMove_ID )
      $to_move = BLACK;
   else if( $White_ID == $ToMove_ID )
      $to_move = WHITE;
   else if( $ToMove_ID )
      error("database_corrupted", "game.bad_ToMove_ID($gid)");

   if( $Status != 'FINISHED' and ($Maintime > 0 or $Byotime > 0) )
   {
      // LastTicks may handle -(time spend) at the moment of the start of vacations
      $ticks = get_clock_ticks($ClockUsed) - $LastTicks;
      $hours = ticks_to_hours($ticks);

      if( $to_move == BLACK )
      {
         time_remaining($hours, $game_row['Black_Maintime'], $game_row['Black_Byotime'],
                        $game_row['Black_Byoperiods'], $Maintime,
                        $Byotype, $Byotime, $Byoperiods, false);
      }
      else
      {
         time_remaining($hours, $game_row['White_Maintime'], $game_row['White_Byotime'],
                        $game_row['White_Byoperiods'], $Maintime,
                        $Byotype, $Byotime, $Byoperiods, false);
      }
   }

   $may_add_time = $my_game && allow_add_time_opponent( $game_row, $my_id);


   $no_marked_dead = ( $Status == 'PLAY' or $Status == 'PASS' or
                       $action == 'choose_move' or $action == 'domove' );

   $TheBoard = new Board( );
   if( !$TheBoard->load_from_db( $game_row, $move, $no_marked_dead) )
      error('internal_error', "game load_from_db $gid");
   $movecol= $TheBoard->movecol;
   $movemsg= $TheBoard->movemsg;


   $extra_message = false;

   if( $just_looking ) //no process except 'movechange'
   {
      $validation_step = false;
      $may_play = false;
      if( $Status == 'FINISHED' )
      {
         $extra_message = "<font color=\"blue\">" . score2text($Score, true) . "</font>";
      }
   }
   else switch( $action )
   {
      case 'choose_move': //single input pass
      {
         if( $Status != 'PLAY' && $Status != 'PASS'
          && $Status != 'SCORE' && $Status != 'SCORE2' //after resume
           )
            error('invalid_action',"game.choose_move.$Status");

         $validation_step = false;
      }
      break;

      case 'domove': //for validation after 'choose_move'
      {
         if( $Status != 'PLAY' && $Status != 'PASS'
          && $Status != 'SCORE' && $Status != 'SCORE2' //after resume
           )
            error('invalid_action',"game.domove.$Status");

         $validation_step = true;
{//to fix old way Ko detect. Could be removed when no more old way games.
  if( !@$Last_Move ) $Last_Move= number2sgf_coords($Last_X, $Last_Y, $Size);
}
         check_move( $TheBoard, $coord, $to_move);
//ajusted globals by check_move(): $Black_Prisoners, $White_Prisoners, $prisoners, $nr_prisoners, $colnr, $rownr;
//here, $prisoners list the captured stones of play (or suicided stones if, a day, $suicide_allowed==true)
         $game_row['Black_Prisoners'] = $Black_Prisoners;
         $game_row['White_Prisoners'] = $White_Prisoners;

         $stonestring = '';
         reset($prisoners);
         while( list($dummy, list($x,$y)) = each($prisoners) )
         {
            $stonestring .= number2sgf_coords($x, $y, $Size);
         }

         if( strlen($stonestring) != $nr_prisoners*2 )
            error('move_problem');

         $TheBoard->set_move_mark( $colnr, $rownr);
         //$coord must be kept for validation by confirm.php
      }
      break;

      case 'handicap': //multiple input step + validation
      {
         if( $Status != 'PLAY' or !( $Handicap>1 && $Moves==0 ) )
            error('invalid_action',"game.handicap.$Status");

         $paterr = '';
         $patdone = 0;
         if( ENA_STDHANDICAP && !$stonestring && !$coord
            && ( $StdHandicap=='Y' or @$_REQUEST['stdhandicap'] ) )
         {
            $stonestring = get_handicap_pattern( $Size, $Handicap, $paterr);
            $extra_message = "<font color=\"green\">"
              . T_('A standard placement of handicap stones has been requested.')
              . "</font>";
            //$coord = ''; // $coord is incoherent with the following
            $patdone = 1;
         }

         check_handicap( $TheBoard, $coord); //adjust $stonestring
         if( (strlen($stonestring)/2) < $Handicap )
         {
            $validation_step = false;
            $extra_message = "<font color=\"green\">" .
              T_('Place your handicap stones, please!') . "</font>";
            if( ENA_STDHANDICAP && !$patdone && strlen($stonestring)<2 )
            {
               $extra_message.= "<br><a href=\"game.php?gid=$gid".URI_AMP."stdhandicap=t\">"
                 . T_('Standard placement') . "</a>";
            }
         }
         else
            $validation_step = true;

         if( $paterr )
            $extra_message = "<font color=\"red\">" . $paterr .
                              "</font><br>" . $extra_message;
         $coord = ''; // already processed/stored in $stonestring
      }
      break;

      case 'resign': //for validation
      {
         $validation_step = true;
         $extra_message = "<font color=\"red\">" . T_('Resigning') . "</font>";
      }
      break;

      case 'add_time': //add-time for opponent
      {
         // check for validity
         if ( !$may_add_time )
            error('invalid_action', "game.add_time");

         $validation_step = true;
      }
      break;


      case 'pass': //for validation
      {
         if( $Status != 'PLAY' and $Status != 'PASS' )
            error('invalid_action',"game.pass.$Status");

         $validation_step = true;
         $extra_message = "<font color=\"green\">" . T_('Passing') . "</font>";
      }
      break;

      case 'delete': //for validation
      {
         if( !$too_few_moves or
           !($Status='PLAY' or $Status='PASS' or $Status='SCORE' or $Status='SCORE2')
            )
            error('invalid_action',"game.delete.$Status");

         $validation_step = true;
         $extra_message = "<font color=\"red\">" . T_('Deleting game') . "</font>";
      }
      break;

      case 'remove': //multiple input step
      {
         if( $Status != 'SCORE' and $Status != 'SCORE2' )
            error('invalid_action',"game.remove.$Status");

         $validation_step = false;
         check_remove( $TheBoard, $coord);
//ajusted globals by check_remove(): $score, $stonestring;

         $done_url = "game.php?gid=$gid".URI_AMP."a=done"
            . ( $stonestring ? URI_AMP."stonestring=$stonestring" : '' );

         $extra_message = "<font color=\"blue\">" . T_('Score') . ": " .
             score2text($score, true) . "</font>";
         $extra_message.= "<P>";
         $extra_message.= "<font color=\"green\">"
            . sprintf( T_("Please mark dead stones and click %s'done'%s when finished."),
                        "<a href=\"$done_url\">", '</a>' )
            . "</font>";
         $coord = ''; // already processed/stored in $stonestring
      }
      break;

      case 'done': //for validation after 'remove'
      {
         if( $Status != 'SCORE' and $Status != 'SCORE2' )
            error('invalid_action',"game.done.$Status");

         $validation_step = true;
         check_remove( $TheBoard);
//ajusted globals by check_remove(): $score, $stonestring;

         $extra_message = "<font color=\"blue\">" . T_('Score') . ": " .
             score2text($score, true) . "</font>";
      }
      break;

      default:
      {
         error('invalid_action',"game.noaction.$Status");
      }
   }
   if( $validation_step ) $may_play = false;


/*
 : Viewing of game messages while read or downloaded (sgf):
 : Game  : Text ::         Viewed by         :: sgf+comments by : sgf only :
 : Ended : Tag  :: Writer : Oppon. : Others  :: Writer : Oppon. : any ones :
 : ----- : ---- :: ------ : ------ : ------- :: ------ : ------ : -------- :
 : no    : none :: yes    : yes    : no      :: yes    : yes    : no       :
 : no    : <c>  :: yes    : yes    : yes     :: yes    : yes    : yes      :
 : no    : <h>  :: yes    : no     : no      :: yes    : no     : no       :
 : yes   : none :: yes    : yes    : no      :: yes    : yes    : no       :
 : yes   : <c>  :: yes    : yes    : yes     :: yes    : yes    : yes      :
 : yes   : <h>  :: yes    : yes    : yes     :: yes    : yes    : yes      :
 : ----- : ---- :: ------ : ------ : ------- :: ------ : ------ : -------- :
  corresponding $html_mode (F= a filter only keeping <c> and <h> blocks):
 : no    : -    :: gameh  : game   : F+game  ::   ... see sgf.php ...
 : yes   : -    :: gameh  : gameh  : F+gameh ::
*/

   if( $Status == 'FINISHED' )
     $html_mode= 'gameh';
   else
     $html_mode= 'game';

   if( $my_game )
   {
      if( $my_id == $Black_ID )
      {
         $my_color= 'B';
         $opponent_ID= $White_ID;
         $movemsg = make_html_safe($movemsg, $movecol==BLACK ? 'gameh' : $html_mode );
      }
      else //if( $my_id == $White_ID )
      {
         $my_color= 'W';
         $opponent_ID= $Black_ID;
         $movemsg = make_html_safe($movemsg, $movecol==WHITE ? 'gameh' : $html_mode );
      }

      if ($Size >= $player_row["NotesCutoff"])
      {
        $notesheight = $player_row["NotesLargeHeight"];
        $noteswidth = $player_row["NotesLargeWidth"];
        $notesmode = $player_row["NotesLargeMode"];
      }
      else
      {
        $notesheight = $player_row["NotesSmallHeight"];
        $noteswidth = $player_row["NotesSmallWidth"];
        $notesmode = $player_row["NotesSmallMode"];
      }
      if( isset($_REQUEST['notesmode']) )
         $notesmode= strtoupper((string)$_REQUEST['notesmode']);

      $show_notes = true;
      $notes = '';
      $noteshide = ( substr( $notesmode, -3) == 'OFF' ? 'Y' : 'N' );
      if( $noteshide == 'Y' )
         $notesmode = substr( $notesmode, 0, -3);

      if( $tmp=mysql_single_fetch( 'game.gamenotes',
             "SELECT Hidden,Notes FROM GamesNotes"
             ." WHERE gid=$gid AND player='$my_color'") )
      {
         $notes = $tmp['Notes'];
         $noteshide = $tmp['Hidden'];
         unset( $tmp);
      }

      if( @$_REQUEST['savenotes'] or @$_REQUEST['togglenotes'] )
      {
         if( @$_REQUEST['togglenotes'] )
            $noteshide = ($noteshide == 'Y' ? 'N' : 'Y' );

         if( @$_REQUEST['savenotes'] )
            $notes = rtrim(get_request_arg('gamenotes'));

         // note: PRIMARY KEY (gid,player) is needed for:
         mysql_query(
                 "REPLACE INTO GamesNotes (gid,player,Hidden,Notes)"
               . " VALUES ($gid,'$my_color','$noteshide','"
                  . mysql_addslashes($notes) . "')")
            or error('mysql_query_failed', 'game.replace_gamenote');
      }
/*
      else if( $show_notes && @$_REQUEST['movechange'] )
      {
         $notes = rtrim(get_request_arg('gamenotes'));
      }
*/
   }
   else // !$my_game
   {
      $opponent_ID= 0;
      $movemsg = game_tag_filter( $movemsg);
      $movemsg = make_html_safe($movemsg, $html_mode );
      $show_notes = false;
      $noteshide = 'Y';
   }

   if( ENA_MOVENUMBERS )
   {
      $movenumbers= (int)@$player_row['MoveNumbers'];
      if( isset($_REQUEST['movenumbers']) )
         $movenumbers= (int)$_REQUEST['movenumbers'];
   }
   else
      $movenumbers= 0;

   if( $logged_in )
      $TheBoard->set_style( $player_row);


   $title = T_("Game") ." #$gid,$move";
   start_page($title, true, $logged_in, $player_row, $TheBoard->style_string());



   echo "<FORM name=\"game_form\" action=\"game.php?gid=$gid\" method=\"POST\">\n";
   $page_hiddens = array();
   // [ game_form start

   echo "<table align=center>\n<tr><td>"; //board & associates table {--------

   if( $movenumbers>0 )
   {
      $tmp= (int)@$player_row['MoveModulo'];
      if( $tmp >= 0 )
      {
         $TheBoard->move_marks( $move-$movenumbers, $move, $tmp);
         $TheBoard->draw_captures_box( T_('Captures'));
      }
   }
   echo "</td><td>\n";

   $TheBoard->movemsg= $movemsg;
   $TheBoard->draw_board( $may_play, $action, $stonestring);
   //TODO: javascript move buttons && numbers hide

   if( $extra_message ) //score messages
   {
      echo "<center><p>$extra_message";
      if( $validation_step )
         echo ' - ' . T_('Hit "Submit" to confirm');
      echo "</p></center>";
   }
   else
      echo '<br>';

   $cols = 2;
   if( $show_notes && $noteshide != 'Y' )
   {
      if( $notesmode == 'BELOW' )
         echo "</td></tr>\n<tr><td colspan=$cols class=GameNotesBelow>";
      else //default 'RIGHT'
      {
         $cols++;
         echo "</td>\n<td class=GameNotesRight>";
      }
      draw_notes( 'N', $notes, $notesheight, $noteswidth);
      $show_notes = false;
   }

   // colspan = captures+board column
   echo "</td></tr>\n<tr><td colspan=$cols class=UnderBoard>";

   if( $validation_step )
   {
      if( $show_notes )
      {
         draw_notes('Y');
         $show_notes = false;
      }

      if ( $action == 'add_time' )
         draw_add_time( $game_row );
      else
         draw_message_box( $message);
   }
   else if( $Moves > 1 )
   {
      draw_moves();
      if( $show_notes )
      {
         draw_notes('Y');
         $show_notes = false;
      }
   }

      if( $show_notes )
      {
         draw_notes('Y');
         $show_notes = false;
      }

      //if( $my_game ) //sgf comments may be viewed by observers
      {
         echo "\n<DIV class=Comments>"
            . anchor( "game_comments.php?gid=$gid"
                    , T_('Comments')
                    , ''
                    , array( 'accesskey' => 'c'
                           , 'target' => $FRIENDLY_SHORT_NAME.'_game_comments'
                    ) )
            . "</DIV>\n";
      }

   echo "</td></tr>\n</table>\n"; //board & associates table }--------


   // ] game_form end
   //$page_hiddens['gid'] = $gid; //set in the URL (allow a cool OK button in the browser)
                     //and more: a hidden gid may already be set by draw_moves()
   $page_hiddens['action'] = $action;
   $page_hiddens['move'] = $move;
   if( @$coord )
      $page_hiddens['coord'] = $coord;
   if( @$stonestring )
      $page_hiddens['stonestring'] = $stonestring;

   if( @$_REQUEST['movenumbers'] )
      $page_hiddens['movenumbers'] = $_REQUEST['movenumbers'];
   if( @$_REQUEST['notesmode'] )
      $page_hiddens['notesmode'] = $_REQUEST['notesmode'];

   foreach( $page_hiddens as $key => $val )
   {
      echo "<input type=\"hidden\" name=\"$key\" value=\"$val\">";
   }
   echo "</FORM>\n";


   echo "<HR>\n";
   draw_game_info($game_row, $TheBoard);
/*
   $txt= draw_board_info($TheBoard);
   if( $txt )
      echo "<div id=\"boardInfos\">$txt</div>\n";
*/
   echo "<HR>\n";



   if( $may_play or $validation_step ) //should be "from status page" as the nextgame option
   {
      $menu_array[T_('Skip to next game')] = "confirm.php?gid=$gid".URI_AMP."nextskip=t";
   }

   if( !$validation_step )
   {
      if( $action == 'choose_move' )
      {
         if( $Status != 'SCORE' && $Status != 'SCORE2' )
            $menu_array[T_('Pass')] = "game.php?gid=$gid".URI_AMP."a=pass";

         $menu_array[T_('Resign')] = "game.php?gid=$gid".URI_AMP."a=resign";

         if( $too_few_moves )
            $menu_array[T_('Delete game')] = "game.php?gid=$gid".URI_AMP."a=delete";
      }
      else if( $action == 'remove' )
      {
         if( @$done_url )
            $menu_array[T_('Done')] = $done_url;

         $menu_array[T_('Resume playing')] = "game.php?gid=$gid".URI_AMP."a=choose_move";

         if( $too_few_moves )
            $menu_array[T_('Delete game')] = "game.php?gid=$gid".URI_AMP."a=delete";
      }
      else if( $action == 'handicap' )
      {
         $menu_array[T_('Delete game')] = "game.php?gid=$gid".URI_AMP."a=delete";
      }
      else if( $Status == 'FINISHED' && $my_game && $opponent_ID > 0) //&& $just_looking
      {
         $menu_array[T_('Send message to user')] = "message.php?mode=NewMessage".URI_AMP."uid=$opponent_ID" ;
         $menu_array[T_('Invite this user')] = "message.php?mode=Invite".URI_AMP."uid=$opponent_ID" ;
      }

      if ( $action != 'add_time' && $may_add_time )
         $menu_array[T_('Add time for opponent')] = "game.php?gid=$gid".URI_AMP."a=add_time#addtime";

      $menu_array[T_('Download sgf')] = ( $has_sgf_alias ? "game$gid.sgf" : "sgf.php?gid=$gid");

      if( $my_game && $Moves>0 && !$has_sgf_alias )
      {
         $menu_array[T_('Download sgf with all comments')] = "sgf.php/?gid=$gid".URI_AMP."owned_comments=1" ;
      }

      if( ($Status != 'FINISHED') and !$my_game and $logged_in )
      {
         if( is_on_observe_list( $gid, $my_id ) )
            $menu_array[T_('Remove from observe list')] = "game.php?gid=$gid".URI_AMP."toggleobserve=t";
         else
            $menu_array[T_('Add to observe list')] = "game.php?gid=$gid".URI_AMP."toggleobserve=t";
      }

      if ( has_observers( $gid ) )
         $menu_array[T_('Show observers')] = "users.php?observe=$gid";
   }

   end_page(@$menu_array);
}

function draw_moves()
{
   global $TheBoard, $gid, $move, $Size;

   //basic_safe() because inside <option></option>
   $trmov = basic_safe(T_('Move'));
   $trpas = basic_safe(T_('Pass'));
   $trsco = basic_safe(T_('Scoring'));
   $trres = basic_safe(T_('Resign'));

   $str = '';
   foreach( $TheBoard->moves as $MoveNr => $sub )
   {
      list( $Stone, $PosX, $PosY) = $sub;
      if( $Stone != BLACK and $Stone != WHITE ) continue;

      switch( $PosX )
      {
         case POSX_PASS :
            $c = $trpas;
            break;
         case POSX_SCORE :
            $c = $trsco;
            break;
         case POSX_RESIGN :
            $c = $trres;
            break;
         default :
            if( $PosX < 0)
               continue;
            $c = number2board_coords($PosX, $PosY, $Size);
            break;
      }

      if( $Stone == WHITE ) $c = str_repeat('&nbsp;', 12) . $c;
      if( $MoveNr < 10 ) $c = '&nbsp;'.$c;
      $str = sprintf('<OPTION value="%d" %s>%s&nbsp;%s:&nbsp;&nbsp;%s</OPTION>' . "\n"
                 , $MoveNr, ($MoveNr == $move ? ' selected' : '')
                 , $trmov, $MoveNr, $c)
          . $str;
   }

   // add selectbox to show specifc move
   echo '<SELECT name="gotomove" size="1"';
   if( ALLOW_JSCRIPT )
   {
      //echo " onchange=\"javascript:alert('Index: ' + this.selectedIndex + ' Valeur: ' + this.options[this.selectedIndex].value );\"";
      //echo " onchange=\"javascript:this.form.submit();\"";
      echo " onchange=\"javascript:this.form['movechange'].click();\"";
   }
   echo ">\n$str</SELECT>\n";
   echo '<INPUT type="HIDDEN" name="gid" value="' . $gid . "\">";
   echo '<INPUT type="submit" name="movechange" value="' . T_('View move') . "\">";
}

function draw_message_box(&$message)
{
   $tabindex=1;
   echo "<TABLE class=MessageForm>"
      . "<TR class=Message>"
      . "<TD class=Rubric>" . T_('Message') . ":</TD>"
      . '<TD><textarea name="message" tabindex="'.($tabindex++)
         . '" cols="50" rows="8">'.textarea_safe( $message).'</textarea></TD>'
      . "</TR>"
      . "<TR class=Submit>"
      . "<TD></TD>"
      . '<TD><input type=submit name="nextgame" tabindex="'.($tabindex++)
         .'" value="'.T_('Submit and go to next game').'">'
         .'<input type=submit name="nextstatus" tabindex="'.($tabindex++)
         .'" value="'.T_("Submit and go to status").'"></TD>'
      . "</TR>"
      . "<TR class=Back>"
      . '<TD colspan=2><input type=submit name="nextback" tabindex="'.($tabindex++)
         .'" value="'.T_("Go back").'"></TD>'
      . "</TR>"
      . "</TABLE>"
      ;

}

function draw_add_time( $game_row )
{
   $tabindex=10; //TODO: fix this start value
   echo '
    <a name="addtime"></a>
      <TABLE class=AddtimeForm>
        <TR>
          <TD>' . T_('Choose how much additional time you wish to give your opponent') . ':</TD>
        </TR>
        <TR>
          <TD>
           <SELECT name="add_days" size="1"  tabindex="'.($tabindex++).'">';

   //basic_safe() because inside <option></option>
   $trday = basic_safe(T_('day'));
   $trdays = basic_safe(T_('days'));
   for( $i=0; $i <= MAX_ADD_DAYS; $i++)
   {
      echo
         sprintf( "<OPTION value=\"%d\"%s>%s %s</OPTION>\n",
            $i, ($i==1 ? ' selected' : ''),
            $i, ($i>1 ? $trdays : $trday) );
   }
   echo '  </SELECT>
           &nbsp;' . T_('added to maintime of your opponent.') . '
          </TD>
        </TR>';

   if ( $game_row['Byotype'] != 'FIS'
      && $game_row['Byotime'] > 0 && $game_row['Byoperiods'] > 0 ) // no byoyomi-reset if no byoyomi
   {
      echo '<TR>
              <TD>
                <input type="checkbox" checked name="reset_byoyomi" tabindex="'.($tabindex++).'" value="1"'
                   . '>&nbsp;' . T_('Reset byoyomi settings when re-entering') . '
              </TD>
            </TR>';
   }

   echo '<TR>
          <TD align=left>
<input type=submit name="nextaddtime" tabindex="'.($tabindex++).'" value="' . T_('Add Time') . '"
><input type=submit name="nextback" tabindex="'.($tabindex++).'" value="' . T_('Cancel') . '"
></TD>
        </TR>
      </TABLE>
';
}

function draw_game_info(&$game_row, &$board)
{
   echo '<table class=GameInfos>' . "\n";

   $cols = 4;

   //black rows
   echo '<tr id="blackInfo">' . "\n";
   echo "<td class=Color><img class=InTextStone src=\"17/b.gif\" alt=\"" . T_('Black') ."\"></td>\n";
   echo '<td class=Name>' .
      user_reference( REF_LINK, 1, '', $game_row['Black_ID'],
                      $game_row['Blackname'], $game_row['Blackhandle']) .
      ( $game_row['Blackwarning'] ?
        '&nbsp;&nbsp;&nbsp;<span class=OnVacation>' . T_('On vacation') . '</span>' : '' ) .
      "</td>\n";

   echo '<td class=Ratings>'
      . echo_game_rating( $game_row['Black_ID']
                     , $game_row['Black_Start_Rating']
                     , $game_row['Status']==='FINISHED'
                        ? $game_row['Black_End_Rating'] : $game_row['Blackrating'])
      . "</td>\n";
   echo '<td class=Prisoners>' . T_('Prisoners') . ': ' . $game_row['Black_Prisoners'] . "</td>\n";
   echo "</tr>\n";

   if( $game_row['Status'] != 'FINISHED' )
   {
      echo '<tr id="blackTime">' . "\n";
      echo "<td colspan=\"" . $cols . "\">\n" . T_("Time remaining") . ": " .
         echo_time_remaining( $game_row['Black_Maintime'], $game_row['Byotype']
                       ,$game_row['Black_Byotime'], $game_row['Black_Byoperiods']
                       ,$game_row['Byotime']) .
         "</td>\n</tr>\n";
   }


   //white rows
   echo '<tr id="whiteInfo">' . "\n";
   echo "<td class=Color><img class=InTextStone src=\"17/w.gif\" alt=\"" . T_('White') ."\"></td>\n";
   echo '<td class=Name>' .
      user_reference( REF_LINK, 1, '', $game_row['White_ID'],
                      $game_row['Whitename'], $game_row['Whitehandle']) .
      ( $game_row['Whitewarning'] ?
        '&nbsp;&nbsp;&nbsp;<span class=OnVacation>' . T_('On vacation') . '</span>' : '' ) .
      "</td>\n";

   echo '<td class=Ratings>'
      . echo_game_rating( $game_row['White_ID']
                     , $game_row['White_Start_Rating']
                     , $game_row['Status']==='FINISHED'
                        ? $game_row['White_End_Rating'] : $game_row['Whiterating'])
      . "</td>\n";
   echo '<td class=Prisoners>' . T_('Prisoners') . ': ' . $game_row['White_Prisoners'] . "</td>\n";
   echo "</tr>\n";


   if( $game_row['Status'] != 'FINISHED' )
   {
      echo '<tr id="whiteTime">' . "\n";
      echo "<td colspan=\"" . $cols . "\">\n" . T_("Time remaining") . ": " .
         echo_time_remaining( $game_row['White_Maintime'], $game_row['Byotype']
                       ,$game_row['White_Byotime'], $game_row['White_Byoperiods']
                       ,$game_row['Byotime']) .
         "</td>\n</tr>\n";
   }


   //game rows
   $sep = ',&nbsp;&nbsp;&nbsp;';
   echo '<tr id="gameRules">' . "\n";
   echo "<td colspan=\"" . $cols . "\">" . T_('Rules') . ': ';
   echo T_('Komi') . ': ' . $game_row['Komi'] ;
   echo $sep . T_('Handicap') . ': ' . $game_row['Handicap'];
   echo $sep . T_('Rated game') . ': ' .
      ( $game_row['Rated'] == 'N' ? T_('No') : T_('Yes') ) . "</td>\n";

   echo "</tr>\n";

   echo '<tr id="gameTime">' . "\n";
   echo "<td colspan=\"" . $cols . "\">" . T_('Time limit') . ': ' .
      echo_time_limit( $game_row['Maintime'], $game_row['Byotype']
                  ,$game_row['Byotime'], $game_row['Byoperiods']) . "</td>\n";

   echo "</tr>\n";

   if( isset($board) )
   {
      $txt= draw_board_info($board);
      if( $txt )
         echo "<tr id=\"boardInfos\" class=BoardInfos><td colspan=$cols\n>$txt</td></tr>\n";
   }

   echo "</table>\n";
}

function draw_board_info($board)
{
   if( count($board->infos) <= 0 )
      return '';

   $fmts= array(
      //array(POSX_ADDTIME, $MoveNr, $Stone, $Hours, $PosY);
      POSX_ADDTIME => array(
         T_('%2$s had added %4$s to %3$s %5$s at move %1$d'),
         array( 0, null), //MoveNr
         array( 1, array( WHITE => T_('White'), BLACK => T_('Black'))), //From
         array( 1, array( BLACK => T_('White'), WHITE => T_('Black'))), //To
         array( 2, 'echo_time'), //Hours
         array( 3, array( 0 => '', 1 => T_('and restarted byoyomi'))), //Reset
      ),
   );

   $txt= '';
   foreach( $board->infos as $row )
   {
      $key = array_shift($row);
      $sub = @$fmts[$key];
      if( $sub )
      {
         //echo var_export($row, true);
         $fmt = array_shift($sub);
         $val = array();
         for( $i=0; $i<count($sub); $i++ )
         {
            list($n, $fct) = $sub[$i];
            //echo "$n => $tmp<br>";
            if( is_array($fct) )
               $val[$i] = $fct[$row[$n]];
            else if( is_string($fct) )
               $val[$i] = $fct($row[$n]);
            else
               $val[$i] = $row[$n];
         }
         //echo var_export($val, true);
         $str= vsprintf($fmt, $val);
         if( $str )
            $txt.= "<dd>$str</dd\n>";
      }
   }
   if( $txt )
      $txt= "<div class=BoardInfos><dl>$txt</dl></div>\n";
   return $txt;
}

function echo_game_rating( $uid, $start_rating, $end_rating)
{
   return
        "<span class=StartRating>"
      . echo_rating( $start_rating, true, $uid )
      . "</span>"
      . "<span class=Separator>-</span>"
      . "<span class=EndRating>"
      . echo_rating( $end_rating, true, $uid )
      . "</span>"
      ;
}


function draw_notes( $collapsed='N', $notes='', $height=0, $width=0)
{
   if( $collapsed == 'Y' )
   {
      //echo textarea_safe( $notes) . "\n";
      echo "  <input name=\"togglenotes\" type=\"submit\" value=\""
               . T_('Show notes') . "\">";
      return;
   }

   if( $height<3 ) $height= 3;
   if( $width<15 ) $width= 15;

   echo " <table class=GameNotes>\n";
   echo "  <tr><th>" . T_('Private game notes') . "</th></tr>\n";
   echo "  <tr><td class=Notes>\n";
   echo "   <textarea name=\"gamenotes\" id=\"gameNotes\" cols=\"$width\" rows=\"$height\">"
            . textarea_safe( $notes) . "</textarea>\n";
   echo "  </td></tr>\n";
   echo "  <tr><td><input name=\"savenotes\" type=\"submit\" value=\""
            . T_('Save notes') . "\">";

   if( $collapsed == 'N' )
   {
   echo "<input name=\"togglenotes\" type=\"submit\" value=\""
            . T_('Hide notes') . "\">";
   }

   echo "</td></tr>\n";
   echo "</table>\n";
}

?>
